<?php if (!defined('PmWiki')) exit();

SDV($PageAttributes['passwdwikipublisher'], '$[Set new publish password:]');
SDV($DefaultPasswords['wikipublisher'], '');
SDV($AuthCascade['wikipublisher'], 'read');
SDV($FmtPV['$PasswdWikipublisher'], 'PasswdVar($pn, "wikipublisher")');

SDV($EnablePDF,false);
SDV($MarkupEnabled['mailform'],0);
if ($EnablePDF) { SDV($PDFCheckboxFmt,
    " &nbsp;<input type='checkbox' name='format' value='makepdf' checked='checked'/>
    <img src='\$FarmPubDirUrl/images/pdficonsmall.gif' align='top' alt='PDF' />");
    SDV($PDFTypesetFmt, " &nbsp;<input type='submit' value='$[Typeset]' />");
    $PDFTypesetVFmt = str_replace('[Typeset]','Typeset',$PDFTypesetFmt);  # transitional code
    SDV($PDFOptionsFmt, 
    " &nbsp;<input type='submit' name='pdfoptions' value='$[PDF options]' />");
    SDV($WikipublisherTargetFmt, '_blank');
    SDV($WikipublisherUrlFmt,'http://www.wikipublisher.org/cgi-bin/mkpdf.pl');
} else SDV($PDFTypesetFmt, " <input type='submit' value='$[Publish]' />");
SDV($PDFIncludeFmt,
    "<input type='checkbox' name='include' value='include' \$Checked/>$[Include this page]\n");
if ($action=='browse') {
    $HTMLStylesFmt['pdf'] = "
form.pdf2you { float: right; margin-left:5px; }
#wikitext a.pdf2you:hover { border-bottom-style: none; }";
    SDV($PageTypesetFmt,"<form 
    class='pdf2you' action='\$ScriptUrl' method='get'><input 
    type='hidden' name='n' value='\$FullName' /><input
    type='hidden' name='action' value='texprint' /><a class='pdf2you' 
    href='\$PageUrl?action=print&ptype=print&format=makepdf'><img align='absmiddle'  
    src='\$FarmPubDirUrl/images/pdficon.gif' title='Typeset page' /></a> &nbsp;<input
    class='pubbutton' type='submit' value='$[options]' /></form>\n");
    SDV($HandleBrowseFmt,array(&$PageStartFmt,
    &$PageTypesetFmt,&$PageRedirectFmt,'$PageText',&$PageEndFmt));
} elseif ($action=='texerror') {
	$MarkupEnabled['mailform'] = 1;
        Markup('wikipublisherr', '>links',
          '/\\(:wikipublishererror(\\s.*?)?:\\)/e',
          "WikipublisherErrorBox(\$pagename, ParseArgs(PSS('$1')))");
        SDV($HandleActions['texerror'], 'HandleWikipublisherError');
        if (isset($_GET['support'])) {
            SDV($WPSupportAddress, $_GET['support']);
            unset($_GET['support']);
        }
} elseif ($action=='mailform') { 
	$MarkupEnabled['mailform'] = 1;
	SDV($MailFormAddresses['support'], 'don@dis.org.nz');
} elseif ($format == 'makepdf' && !isset($_GET['pdfoptions']))  {
        if ($_REQUEST['cancel']) { Redirect($pagename); exit; }
        $_GET['format'] = 'pdf';
        Markup('wikipublisher', '>links',
          '/\\(:wikipublisher(\\s.*?)?:\\)/e',
          "WikipublisherBox(\$pagename, ParseArgs(PSS('$1')))");
        Markup('wikibookxml', '>links','/\\(:wikibookxml(\\s.*?)?:\\)/e',
          "WikibookXMLBox(\$pagename, ParseArgs(PSS('$1')))");
        $action = 'wikipublisher';
        if ($_GET['ptype']=='book') $HandleAuth['wikipublisher'] = 'wikipublisher';
        SDV($HandleActions['wikipublisher'], 'HandleWikipublisherRequest');
}

## WikipublisherCancel inserts a Cancel form and button
function WikipublisherCancel($pagename, $opt) {
  return FmtPageName("<form class='publish' action='\$ScriptUrl'
    method='get'><input type='hidden' name='n' value='\$FullName' /><input
    class='pubbutton' type='submit' value=\"{$opt['cancel']}\" /></form>", 
    $pagename);
}

## WikipublisherBox generates the output of the (:wikipublisher:) markup.
## If $WikipublisherBoxFmt is defined, that is used, otherwise a form
## is generated.  Options include email=, size=, wait=, cancel=.
function WikipublisherBox($pagename, $opt) {
  global $WikipublisherBoxFmt,$EnablePDFDebug,$WPVersionNum,$EnableLatex,
    $EnablePDFVerify, $EnablePathInfo, $EnableAuthUser, $WPUserID;
  if (isset($WikipublisherBoxFmt)) 
      return FmtPageName($WikipublisherBoxFmt, $pagename);
  SDVA($WikipublisherBoxOpt, array('size' => '30', 
    'email' => FmtPageName('$[Email]', $pagename),
    'wait'  => FmtPageName('$[Download]', $pagename),
    'latex' => FmtPageName('$[(LaTeX)]', $pagename),
    'debug' => FmtPageName('$[(debug)]', $pagename),
    'cancel' => FmtPageName('$[Back to page]', $pagename)
    ));
  $opt = array_merge($WikipublisherBoxOpt, (array)$opt);
  $out[] = FmtPageName("<form class='publish' target='\$WikipublisherTargetFmt'
    action='\$WikipublisherUrlFmt/\$ScriptUrl".
    (@$EnablePathInfo ? '/' : '')."' method='get'>", $pagename);

  SDV($_GET['n'], FmtPageName('$FullName',$pagename));
  foreach($_GET as $name => $value) {
    if (is_array($value))
      for ($i=0;$i<count($value);$i++)
        $out[] = '<input type="hidden" name="' . htmlspecialchars($name) .
	'[]" value="' . htmlspecialchars($value[$i]) . '" />';
    elseif ($value != '') 
      $out[] = '<input type="hidden" name="' . htmlspecialchars($name) .
	'" value="' . preg_replace('/\x91/','&lsquo;', 
            preg_replace('/\x92/','&rsquo;',
            htmlspecialchars(stripmagic($value),ENT_QUOTES))) . '" />';
  }

# pass authentication to wikipublisher
  if (isset($_COOKIE['PHPSESSID']))
      $out[] = '<input type="hidden" name="PHPSESSID" '.
      'value="'.htmlspecialchars($_COOKIE['PHPSESSID'],ENT_QUOTES) . '" />';
  if ($EnableAuthUser) { 
      SDV($WPUserID, 'wikibook');
      $out[] = '<input type="hidden" name="authid" value="'.$WPUserID.'" />';
  }
  
  $out[] = "<input type='hidden' name='wpversion' value='$WPVersionNum' />";
  $out[] = "<input type='text' name='email' value='' 
    size='{$opt['size']}' /> <input class='pubbutton' name='submitemail' 
    type='submit' value=\"{$opt['email']}\" /><br />";
  $out[] = "<input class='pubbutton' type='submit' value=\"{$opt['wait']}\" />";

# format optional buttons
  foreach (array('latex' => 'EnableLatex', 'debug' => 'EnablePDFDebug',
    'verify' => 'EnablePDFVerify') as $k => $v) {
      SDV($$v,false);
      if ($$v) $out[] = " <input class='pubbutton' type='submit' name='" . 
    strtoupper($k) . "' value=\"{$opt[$k]}\" />";
  }

  $cancel = isset($_GET['summaryn']) ? $_GET['summaryn'] : $pagename;
  $out[] = '</form>'.WikipublisherCancel($cancel, array('cancel' => $opt['cancel']));
  return Keep(implode('', $out));
}

## WikibookXMLBox generates the output of the (:wikibookxml:) markup.
function WikibookXMLBox($pagename, $opt) {
  global $WikibookXMLBoxFmt;
  if (isset($WikibookXMLBoxFmt)) 
      return FmtPageName($WikibookXMLBoxFmt, $pagename);
  SDVA($WikibookXMLBoxOpt, array(
    'xml' => FmtPageName('$[Wikibook XML]', $pagename)
    ));
  $opt = array_merge($WikibookXMLBoxOpt, (array)$opt);
  $out[] = FmtPageName("<form class='publish' action='\$ScriptUrl' method='get'>", 
    $pagename);

  SDV($_GET['n'], FmtPageName('$FullName',$pagename));
  foreach($_GET as $name => $value) {
    if (is_array($value))
      for ($i=0;$i<count($value);$i++)
        $out[] = '<input type="hidden" name="' . htmlspecialchars($name) .
	'[]" value="' . htmlspecialchars($value[$i]) . '" />';
    elseif ($value != '') 
      $out[] = '<input type="hidden" name="' . htmlspecialchars($name) .
	'" value="' . preg_replace('/\x91/','&lsquo;', 
            preg_replace('/\x92/','&rsquo;',
            htmlspecialchars(stripmagic($value),ENT_QUOTES))) . '" />';
  }

  $out[] = "<input class='pubbutton' type='submit' 
    value=\"{$opt['xml']}\" /></form>";
  return Keep(implode('', $out));
}

## WikipublisherErrorBox generates the output of the (:wikipublisherr:) markup.
## If $WikipublisherErrorBoxFmt is defined, that is used, otherwise a form
## is generated.
function WikipublisherErrorBox($pagename, $opt) {
  global $WPErrorBoxFmt, $WPSupportAddress, $WPVersion, $MailFormFmt;
  if (isset($WPErrorBoxFmt)) 
      return FmtPageName($WPErrorBoxFmt, $pagename);
  SDVA($WPErrorBoxOpt, array(
    'address' => ($WPSupportAddress) ? $WPSupportAddress : 'support',
    'subject' => FmtPageName('$[Wikipublisher error report]', $pagename),
    'label'   => FmtPageName('$[Email wikipublisher support]', $pagename),
    'redirect'=> 'texerror',
    'cancel'  => FmtPageName('$[Back to page]', $pagename)
    ));
  $opt = array_merge($WPErrorBoxOpt, (array)$opt);
  $body[] = FmtpageName('url: $PageUrl', $pagename);
  foreach($_GET as $name => $value) {
    if (is_array($value))
      for ($i=0;$i<count($value);$i++)
        $body[] = htmlspecialchars($name) . '[]: ' . 
            htmlspecialchars($value[$i]);
    elseif ($value != '') 
      $body[] = htmlspecialchars($name) . ': ' . 
            preg_replace('/\x91/','&lsquo;', preg_replace('/\x92/','&rsquo;',
            htmlspecialchars($value,ENT_QUOTES)));
  }
  $opt['message'] = ($_GET['mailform']) ? '' : implode("\n",$body);
  $out[] = MakeMailForm($pagename, $opt, $MailFormFmt);
  $out[] = WikipublisherCancel($pagename, array('cancel' => $opt['cancel']));
  return Keep(implode('', $out));
}

function HandleWikipublisher($pagename, $auth, $pg) {
  global $HandleWikipublisherFmt, $PageStartFmt, $PageEndFmt, $FmtPV,
       $WikipublisherPage;
  SDVA($WikipublisherPage, array(
      'request' => 'Site.Wikipublisher',
      'error'   => 'Site.WikipublisherError'));
  PCache($pagename,RetrieveAuthPage($pagename,$auth,true,READPAGE_CURRENT));
  $FmtPV['$LastModified'] = '$GLOBALS["CurrentTime"]';
  $nout = FmtPageName('$['.$WikipublisherPage[$pg].']', $pagename);
  SDV($HandleWikipublisherFmt,
      array(&$PageStartFmt, "wiki:$nout", &$PageEndFmt));
  PrintFmt($pagename,$HandleWikipublisherFmt);
}

function HandleWikipublisherRequest($pagename, $auth='wikipublisher') {
  HandleWikipublisher($pagename, $auth, 'request');
}

function HandleWikipublisherError($pagename, $auth='read') {
  HandleWikipublisher($pagename, $auth, 'error');
}
/*
  Copyright 2008 Eemeli Aro <eemeli@gmail.com> Note: untested!!
  To use, put the following in SiteAdmin.AuthUser:
    ip: username ip-address
  By default, PublishPDF sets username to 'wikibook'
*/
$AuthUserFunctions['ip'] = 'AuthUserIP';
function AuthUserIP($pagename, $id, $pw, $pwlist) {
  $i = '';
  foreach ( (array)$pwlist as $d ) {
    if ($d==$id) { $i = $d; continue; }
    if ( $i && ( $_SERVER['REMOTE_ADDR'] == $d ) ) return true;
  }
  return false;
}

?>